#ifndef PROC_CONTROL_H
#define PROC_CONTROL_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "ram_disk.h"
#include "camera.h"

class ProcControl : public QObject
{
    Q_OBJECT

private:

    QFileSystemWatcher *fsMon;
    QTimer             *checkTimer;
    QThread            *rdThread;
    RamDisk            *ramDisk;
    shared_t           *share;
    QStringList         confList;
    QString             file;
    QString             statPath;
    bool                closeOnZero;
    bool                procFileAdded;
    uint                objCount;

    void createCamObjs();
    void createProcFile();
    void startRamdisk();
    void umntThenClose();

private slots:

    void procFileUpdated(const QString &path);

public:

    explicit ProcControl(const QString &procFile, const QString &statDir, shared_t *glbShare, QCoreApplication *parent);

    void objPlusOne(const QString &conf);

public slots:

    void objMinusOne(const QString &conf);
    void closeApp();
    void startApp();

signals:

    void prepForClose();
};

#endif // PROC_CONTROL_H
